## aflplusplus 2.67c

=== gcc_plugin/Makefile ===
#
# american fuzzy lop++ - GCC plugin instrumentation
# -----------------------------------------------
#
# Written by Austin Seipp <aseipp@pobox.com> and
#            Laszlo Szekeres <lszekeres@google.com> and
#            Michal Zalewski and
#            Heiko Eißfeldt  <heiko@hexco.de>
#
# GCC integration design is based on the LLVM design, which comes
# from Laszlo Szekeres.
#
# Copyright 2015 Google Inc. All rights reserved.
# Copyright 2019-2020 AFLplusplus Project. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH ?= $(PREFIX)/lib/afl
BIN_PATH    ?= $(PREFIX)/bin
DOC_PATH    ?= $(PREFIX)/share/doc/afl
MAN_PATH    ?= $(PREFIX)/man/man8

VERSION     = $(shell grep '^$(HASH)define VERSION ' ../config.h | cut -d '"' -f2)
VERSION:sh= grep '^$(HASH)define VERSION ' ../config.h | cut -d '"' -f2

CFLAGS      ?= -O3 -g -funroll-loops -D_FORTIFY_SOURCE=2
CFLAGS = -Wall -I../include -Wno-pointer-sign \
               -DAFL_PATH=\"$(HELPER_PATH)\" -DBIN_PATH=\"$(BIN_PATH)\" \
               -DGCC_VERSION=\"$(GCCVER)\" -DGCC_BINDIR=\"$(GCCBINDIR)\" \
               -Wno-unused-function

CXXFLAGS    = -O3 -g -funroll-loops -D_FORTIFY_SOURCE=2
CXXEFLAGS   = $(CXXFLAGS) -Wall

CC          = gcc
CXX         = g++

MYCC=$(CC:clang=gcc)
MYCXX=$(CXX:clang++=g++)

PLUGIN_PATH = $(shell $(MYCC) -print-file-name=plugin)
PLUGIN_PATH:sh= $(MYCC) -print-file-name=plugin
PLUGIN_FLAGS = -fPIC -fno-rtti -I"$(PLUGIN_PATH)/include"
HASH=\#

GCCVER    = $(shell $(MYCC) --version 2>/dev/null | awk 'NR == 1 {print $$NF}')
GCCVER:sh= gcc --version 2>/dev/null | awk 'NR == 1 {print $$NF}'
GCCBINDIR = $(shell dirname `command -v $(MYCC)` 2>/dev/null )
GCCBINDIR:sh= dirname `command -v $(MYCC)` 2>/dev/null

_SHMAT_OK= $(shell echo '$(HASH)include <sys/ipc.h>@$(HASH)include <sys/shm.h>@int main() { int _id = shmget(IPC_PRIVATE, 65536, IPC_CREAT | IPC_EXCL | 0600); shmctl(_id, IPC_RMID, 0); return 0;}' | tr @ '\n' | $(MYCC) -x c - -o .test2 2>/dev/null && echo 1 || echo 0 ; rm -f .test2 )
_SHMAT_OK:sh= echo '$(HASH)include <sys/ipc.h>@$(HASH)include <sys/shm.h>@int main() { int _id = shmget(IPC_PRIVATE, 65536, IPC_CREAT | IPC_EXCL | 0600); shmctl(_id, IPC_RMID, 0); return 0;}' | tr @ '\n' | $(MYCC) -x c - -o .test2 2>/dev/null && echo 1 || echo 0 ; rm -f .test2

IGNORE_MMAP=$(TEST_MMAP:1=0)
__SHMAT_OK=$(_SHMAT_OK)$(IGNORE_MMAP)
___SHMAT_OK=$(__SHMAT_OK:10=0)
SHMAT_OK=$(___SHMAT_OK:1=1)
_CFLAGS_ADD=$(SHMAT_OK:1=)
CFLAGS_ADD=$(_CFLAGS_ADD:0=-DUSEMMAP=1)

_LDFLAGS_ADD=$(SHMAT_OK:1=)
LDFLAGS_ADD=$(_LDFLAGS_ADD:0=-lrt)

CFLAGS += $(CFLAGS_ADD)
LDFLAGS += $(LDFLAGS_ADD)

PROGS        = ../afl-gcc-pass.so ../afl-gcc-fast ../afl-gcc-rt.o

all: test_shm test_deps $(PROGS) ../afl-gcc-fast.8 test_build all_done

debug:
	@echo _SHMAT_OK = $(_SHMAT_OK)
	@echo IGNORE_MMAP = $(IGNORE_MMAP)
	@echo __SHMAT_OK = $(__SHMAT_OK)
	@echo ___SHMAT_OK = $(___SHMAT_OK)
	@echo SHMAT_OK = $(SHMAT_OK)

test_shm:
	@if [ "$(SHMAT_OK)" == "1" ]; then \
	  echo "[+] shmat seems to be working."; \
	  rm -f .test2; \
	else \
	  echo "[-] shmat seems not to be working, switching to mmap implementation"; \
	fi

test_deps:
	@echo "[*] Checking for working '$(MYCC)'..."
	@type $(MYCC) >/dev/null 2>&1 || ( echo "[-] Oops, can't find '$(MYCC)'. Make sure that it's in your \$$PATH (or set \$$CC and \$$CXX)."; exit 1 )
#	@echo "[*] Checking for gcc for plugin support..."
#	@$(MYCC) -v 2>&1 | grep -q -- --enable-plugin || ( echo "[-] Oops, this gcc has not been configured with plugin support."; exit 1 )
	@echo "[*] Checking for gcc plugin development header files..."
	@test -d `$(MYCC) -print-file-name=plugin`/include || ( echo "[-] Oops, can't find gcc header files. Be sure to install 'gcc-X-plugin-dev'."; exit 1 )
	@echo "[*] Checking for '../afl-showmap'..."
	@test -f ../afl-showmap || ( echo "[-] Oops, can't find '../afl-showmap'. Be sure to compile AFL first."; exit 1 )
	@echo "[+] All set and ready to build."

afl-common.o: ../src/afl-common.c
	$(MYCC) $(CFLAGS) -c $< -o $@ $(LDFLAGS)

../afl-gcc-fast: afl-gcc-fast.c afl-common.o
	$(MYCC) -DAFL_GCC_CC=\"$(MYCC)\" -DAFL_GCC_CXX=\"$(MYCXX)\" $(CFLAGS) afl-gcc-fast.c afl-common.o -o $@ $(LDFLAGS)
	ln -sf afl-gcc-fast ../afl-g++-fast

../afl-gcc-pass.so: afl-gcc-pass.so.cc
	$(MYCXX) $(CXXEFLAGS) $(PLUGIN_FLAGS) -shared afl-gcc-pass.so.cc -o $@

../afl-gcc-rt.o: afl-gcc-rt.o.c
	$(MYCC) $(CFLAGS) -fPIC -c afl-gcc-rt.o.c -o $@

test_build: $(PROGS)
	@echo "[*] Testing the CC wrapper and instrumentation output..."
	@unset AFL_USE_ASAN AFL_USE_MSAN; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. AFL_CC=$(CC) ../afl-gcc-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
#	unset AFL_USE_ASAN AFL_USE_MSAN;             AFL_INST_RATIO=100 AFL_PATH=. AFL_CC=$(CC) ../afl-gcc-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
	@ASAN_OPTIONS=detect_leaks=0 ../afl-showmap -m none -q -o .test-instr0 ./test-instr </dev/null
	@ASAN_OPTIONS=detect_leaks=0 echo 1 | ../afl-showmap -m none -q -o .test-instr1 ./test-instr
	@rm -f test-instr
	@trap 'rm .test-instr0 .test-instr1' 0;if cmp -s .test-instr0 .test-instr1; then echo; echo "Oops, the instrumentation does not seem to be behaving correctly!"; echo; echo "Please post to https://github.com/AFLplusplus/AFLplusplus/issues to troubleshoot the issue."; echo; exit 1; fi
	@echo "[+] All right, the instrumentation seems to be working!"

all_done: test_build
	@echo "[+] All done! You can now use '../afl-gcc-fast' to compile programs."

.NOTPARALLEL: clean

../afl-gcc-fast.8: ../afl-gcc-fast
	@echo .TH $* 8 `date "+%Y-%m-%d"` "afl++" > ../$@
	@echo .SH NAME >> ../$@
	@echo .B $* >> ../$@
	@echo >> ../$@
	@echo .SH SYNOPSIS >> ../$@
	@../$* -h 2>&1 | head -n 3 | tail -n 1 | sed 's/^\.\///' >> ../$@
	@echo >> ../$@
	@echo .SH OPTIONS >> ../$@
	@echo .nf >> ../$@
	@../$* -h 2>&1 | tail -n +4 >> ../$@
	@echo >> ../$@
	@echo .SH AUTHOR >> ../$@
	@echo "afl++ was written by Michal \"lcamtuf\" Zalewski and is maintained by Marc \"van Hauser\" Heuse <mh@mh-sec.de>, Heiko \"hexcoder-\" Eissfeldt <heiko.eissfeldt@hexco.de>, Andrea Fioraldi <andreafioraldi@gmail.com> and Dominik Maier <domenukk@gmail.com>" >> ../$@
	@echo  The homepage of afl++ is: https://github.com/AFLplusplus/AFLplusplus >> ../$@
	@echo >> ../$@
	@echo .SH LICENSE >> ../$@
	@echo Apache License Version 2.0, January 2004 >> ../$@
	ln -sf afl-gcc-fast.8 ../afl-g++-fast.8

install: all
	install -m 755 ../afl-gcc-fast $${DESTDIR}$(BIN_PATH)
	install -m 755 ../afl-gcc-pass.so ../afl-gcc-rt.o $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(DOC_PATH)/README.gcc_plugin.md
	install -m 644 -T README.instrument_list.md $${DESTDIR}$(DOC_PATH)/README.gcc_plugin.instrument_file.md

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]* test-instr .test-instr0 .test-instr1 .test2
	rm -f $(PROGS) afl-common.o ../afl-g++-fast ../afl-g*-fast.8

=== libdislocator/Makefile ===
#
# american fuzzy lop++ - libdislocator
# ----------------------------------
#
# Originally written by Michal Zalewski
#
# Copyright 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops -D_FORTIFY_SOURCE=2
CFLAGS += -I ../include/ -Wall -g -Wno-pointer-sign

CFLAGS_ADD=$(USEHUGEPAGE:1=-DUSEHUGEPAGE)
CFLAGS += $(CFLAGS_ADD)

all: libdislocator.so

VPATH = ..
libdislocator.so: libdislocator.so.c ../config.h
	$(CC) $(CFLAGS) -shared -fPIC libdislocator.so.c -o ../$@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../libdislocator.so

install: all
	install -m 755 -d $${DESTDIR}$(HELPER_PATH)
	install -m 755 ../libdislocator.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(HELPER_PATH)/README.dislocator.md

=== libtokencap/Makefile ===
#
# american fuzzy lop++ - libtokencap
# --------------------------------
#
# Originally written by Michal Zalewski
#
# Copyright 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
DOC_PATH    ?= $(PREFIX)/share/doc/afl
MAN_PATH    ?= $(PREFIX)/man/man8

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops -D_FORTIFY_SOURCE=2
CFLAGS += -I ../include/ -Wall -g -Wno-pointer-sign


UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make
_UNIQ=_QINU_

    _OS_DL = $(_UNIQ)$(UNAME_S)
   __OS_DL =     $(_OS_DL:$(_UNIQ)Linux=$(_UNIQ))
  ___OS_DL =    $(__OS_DL:$(_UNIQ)Darwin=$(_UNIQ))
 ____OS_DL =   $(___OS_DL:$(_UNIQ)$(UNAME_S)=)
_____OS_DL =  $(____OS_DL:$(_UNIQ)="-ldl")

     _OS_TARGET = $(___OS_DL:$(_UNIQ)FreeBSD=$(_UNIQ))
    __OS_TARGET =     $(_OS_TARGET:$(_UNIQ)OpenBSD=$(_UNIQ))
   ___OS_TARGET =    $(__OS_TARGET:$(_UNIQ)NetBSD=$(_UNIQ))
  ____OS_TARGET =   $(___OS_TARGET:$(_UNIQ)Haiku=$(_UNIQ))
 _____OS_TARGET =  $(____OS_TARGET:$(_UNIQ)SunOS=$(_UNIQ))
______OS_TARGET = $(_____OS_TARGET:$(_UNIQ)$(UNAME_S)=)

TARGETS       =  $(______OS_TARGET:$(_UNIQ)=libtokencap.so)

LDFLAGS     += $(_____OS_DL)

#ifeq "$(shell uname)" "Linux"
#  TARGETS = libtokencap.so
#  LDFLAGS     += -ldl
#endif
#ifeq "$(shell uname)" "Darwin"
#  TARGETS = libtokencap.so
#  LDFLAGS     += -ldl
#endif
#ifeq "$(shell uname)" "FreeBSD"
#  TARGETS = libtokencap.so
#endif
#ifeq "$(shell uname)" "OpenBSD"
#  TARGETS = libtokencap.so
#endif
#ifeq "$(shell uname)" "NetBSD"
#  TARGETS = libtokencap.so
#endif
#ifeq "$(shell uname)" "DragonFly"
#  TARGETS = libtokencap.so
#  LDFLAGS     += -ldl
#endif
all: $(TARGETS)

VPATH = ..
libtokencap.so: libtokencap.so.c ../config.h
	$(CC) $(CFLAGS) -shared -fPIC $< -o ../$@ $(LDFLAGS)

.NOTPARALLEL: clean

debug:
	@echo $(UNAME_S)$(_UNIQ) | hexdump -C
	@echo from $(____OS_DL) : $(_UNIQ)$(UNAME_S) = -\> $(_____OS_DL)
	@echo from $(_____OS_DL) : $(_UNIQ) = -ldl -\> $(______OS_DL)
	@echo from $(____OS_DL) : $(_UNIQ)FreeBSD = $(_UNIQ) -\> $(_OS_TARGET)
	@echo from $(_OS_TARGET) : $(_UNIQ)OpenBSD = $(_UNIQ) -\> $(__OS_TARGET)
	@echo from $(__OS_TARGET) : $(_UNIQ)NetBSD = $(_UNIQ) -\> $(___OS_TARGET)
	@echo from $(___OS_TARGET) : $(_UNIQ)$(_UNIQ) = -\> $(____OS_TARGET)
	@echo from $(____OS_TARGET) : $(_UNIQ) = libtokencap.so -\> $(TARGETS)

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../libtokencap.so

install: all
	install -m 755 -d $${DESTDIR}$(HELPER_PATH)
	install -m 755 ../libtokencap.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(DOC_PATH)/README.tokencap.md

=== qemu_mode/libcompcov/Makefile ===
#
# american fuzzy lop++ - libcompcov
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2020 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
DOC_PATH    ?= $(PREFIX)/share/doc/afl
MAN_PATH    ?= $(PREFIX)/man/man8

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -I ../../include/
CFLAGS      += -Wall -Wno-unused-result -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign
LDFLAGS     += -ldl

all: libcompcov.so

libcompcov.so: libcompcov.so.c ../../config.h
	$(CC) $(CFLAGS) -shared -fPIC $< -o ../../$@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../../libcompcov.so compcovtest

compcovtest:	compcovtest.cc
	$(CXX) -std=c++11 $< -o $@ 

install: all
	install -m 755 ../../libcompcov.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(DOC_PATH)/README.compcov.md

=== debian/changelog ===
aflplusplus (2.67c-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Revert "Switch to clang 11"
  * Fix broken symlinks (Closes: #968263)

  [ Raphaël Hertzog ]
  * New upstream version 2.67c
    - this versions disables -march=native when SOURCE_DATE_EPOCH is set
      Closes: #968336
  * Update patches for new upstream release
  * Fix installation path of helper libraries (Closes: #969151)
  * Switch to debhelper compat 13
  * Switch to clang/llvm 10
  * Install the upstream manual pages
  * Update Add-missing-CPPFLAGS.patch to cover afl-performance.o too

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 28 Aug 2020 21:15:22 +0200

aflplusplus (2.66c-1) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Rely on LLVM_CONFIG environment variable to force usage of a specific
    CLANG version
  * Don't duplicate LLVM major version in binary package dependencies

  [ Samuel Henrique ]
  * Configure git-buildpackage for Debian

  [ Sophie Brun ]
  * New upstream version 2.66c (Closes: #956986)
  * Remove unneeded patches
  * Switch to clang 11
  * Update build and installation for new release
  * Wrap-and-sort
  * Update debian/copyright
  * Update source/lintian-overrides
  * Add transitional packages (Closes: #942291)
  * Add a patch to fix spelling errors
  * Don't install upstream installation documentation
  * Patch to add missing CPPFLAGS
  * Bump Standards-Version to 4.5.0 (no change)
  * Re-enable build log scanner as #948009 is fixed
  * Add a patch to fix the file-references-package lintian info

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 07 Aug 2020 11:48:29 +0200

=== debian/control ===
Source: aflplusplus
Section: devel
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Sophie Brun <sophie@offensive-security.com>,
 Raphaël Hertzog <raphael@offensive-security.com>
Build-Depends:
 clang-10,
 debhelper-compat (= 13),
 dh-buildinfo,
 llvm-10-dev,
 python3-dev
Standards-Version: 4.5.0
Homepage: https://github.com/vanhauser-thc/AFLplusplus
Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus

Package: afl++
Architecture: any
Depends: build-essential, ${misc:Depends}, ${shlibs:Depends}
Recommends: afl++-clang, afl++-doc
Suggests: gnuplot
Breaks: afl (<< 2.53c)
Replaces: afl (<< 2.53c)
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl++-fuzz is designed to be practical: it has modest performance
 overhead, uses a variety of highly effective fuzzing strategies, requires
 essentially no configuration, and seamlessly handles complex, real-world use
 cases - say, common image parsing or file compression libraries.
 .
 This package is a fork of the afl package that is no longer maintained.

Package: afl++-clang
Architecture: any
Depends: afl++ (= ${binary:Version}),
         clang-${llvm-major-version},
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: afl++-doc
Breaks: afl-clang (<< 2.53c)
Replaces: afl-clang (<< 2.53c)
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

Package: afl++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: afl++, afl++-clang
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.

Package: afl
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++
Description: transitional dummy package for afl to afl++
 This is a transitional package. It can safely be removed once afl++ is
 installed.

Package: afl-clang
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++-clang
Description: transitional dummy package for afl-clang to afl++-clang
 This is a transitional package. It can safely be removed once afl++-clang is
 installed.

Package: afl-doc
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++-doc
Description: transitional dummy package for afl-doc to afl++-doc
 This is a transitional package. It can safely be removed once afl++-doc is
 installed.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# don't emit NEON instructions whatsoever to prevent FTBFS on machines which
# doesn't support that, see #842143 [thanks to Paul Wise]
ifeq "$(shell dpkg-architecture -q DEB_HOST_ARCH)" "armhf"
export DEB_CFLAGS_MAINT_APPEND = -mfpu=vfpv3
export DEB_CXXFLAGS_MAINT_APPEND = -mfpu=vfpv3
endif

export HOSTNAME =
export PREFIX = /usr

ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
export AFL_NO_X86 = 1
endif

# Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
export LLVM_MAJOR_VERSION = 10
export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)

%:
	dh $@ --with buildinfo

override_dh_auto_build:
	$(MAKE)
	$(MAKE) -C libdislocator
	$(MAKE) -C libtokencap
	$(MAKE) -C llvm_mode

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
#	rm debian/tmp/usr/share/doc/afl++-doc/Changelog.md
#	rm debian/tmp/usr/share/doc/afl++-doc/README.md
	$(MAKE) -C libdislocator install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C libtokencap install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C llvm_mode install DESTDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install
ifneq "$(AFL_NO_X86)" ""
	# Keep only the *-fast* variants on non-x86
	cd debian/afl++/usr/bin/ && rm afl-gcc afl-g++
	cd debian/afl++/usr/lib/afl/ && rm as afl-as
	cd debian/afl++-clang/usr/bin/ && rm afl-clang afl-clang++
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) test
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vllvm-major-version=$(LLVM_MAJOR_VERSION)

override_dh_installdocs:
	dh_installdocs -A README.md -XINSTALL.md

override_dh_compress:
	dh_compress -X.c -X.mp4 -X.sql -XREADME -X.txt

# Exclude afl++-doc from many operations due to embedded binaries
override_dh_buildinfo:
	dh_buildinfo -Nafl++-doc

override_dh_strip_nondeterminism:
	# see #803503
	dh_strip_nondeterminism -Nafl++-doc

override_dh_strip:
	dh_strip -Nafl++-doc

override_dh_makeshlibs:
	dh_makeshlibs -Nafl++-doc

## aflplusplus 2.68c

=== gcc_plugin/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 HELPER_PATH ?= $(PREFIX)/lib/afl
 BIN_PATH    ?= $(PREFIX)/bin
 DOC_PATH    ?= $(PREFIX)/share/doc/afl
-MAN_PATH    ?= $(PREFIX)/man/man8
+MAN_PATH    ?= $(PREFIX)/share/man/man8
 
 VERSION     = $(shell grep '^$(HASH)define VERSION ' ../config.h | cut -d '"' -f2)
 VERSION:sh= grep '^$(HASH)define VERSION ' ../config.h | cut -d '"' -f2

=== libdislocator/Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 VPATH = ..
 libdislocator.so: libdislocator.so.c ../config.h
-	$(CC) $(CFLAGS) -shared -fPIC libdislocator.so.c -o ../$@ $(LDFLAGS)
+	$(CC) $(CFLAGS) $(CPPFLAGS) -shared -fPIC libdislocator.so.c -o ../$@ $(LDFLAGS)
 
 .NOTPARALLEL: clean

=== libtokencap/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 PREFIX      ?= /usr/local
 HELPER_PATH  = $(PREFIX)/lib/afl
 DOC_PATH    ?= $(PREFIX)/share/doc/afl
-MAN_PATH    ?= $(PREFIX)/man/man8
+MAN_PATH    ?= $(PREFIX)/share/man/man8
 
 VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)
 
@@ -70,7 +70,7 @@
 
 VPATH = ..
 libtokencap.so: libtokencap.so.c ../config.h
-	$(CC) $(CFLAGS) -shared -fPIC $< -o ../$@ $(LDFLAGS)
+	$(CC) $(CFLAGS) $(CPPFLAGS) -shared -fPIC $< -o ../$@ $(LDFLAGS)
 
 .NOTPARALLEL: clean

=== custom_mutators/honggfuzz/Makefile ===

CFLAGS = -O3 -funroll-loops -fPIC -Wl,-Bsymbolic

all: honggfuzz.so

honggfuzz.so:	honggfuzz.c input.h mangle.c ../../src/afl-performance.c
	$(CC) $(CFLAGS) -I../../include -I. -shared -o honggfuzz.so honggfuzz.c mangle.c ../../src/afl-performance.c

update:
	@# seriously? --unlink is a dud option? sigh ...
	rm -f mangle.c mangle.h honggfuzz.h
	wget --unlink https://github.com/google/honggfuzz/raw/master/mangle.c
	wget --unlink https://github.com/google/honggfuzz/raw/master/mangle.h
	wget --unlink https://github.com/google/honggfuzz/raw/master/honggfuzz.h

clean:
	rm -f *.o *~ *.so core

=== examples/argv_fuzzing/Makefile ===
#
# american fuzzy lop++ - argvfuzz
# --------------------------------
#
# Copyright 2019-2020 Kjell Braden <afflux@pentabarf.de>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

.PHONY: all install clean

PREFIX     ?= /usr/local
BIN_PATH    = $(PREFIX)/bin
HELPER_PATH = $(PREFIX)/lib/afl

CFLAGS = -fPIC -Wall -Wextra
LDFLAGS = -shared

UNAME_SAYS_LINUX=$(shell uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?)
UNAME_SAYS_LINUX:sh=uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?

_LDFLAGS_ADD=$(UNAME_SAYS_LINUX:1=)
LDFLAGS_ADD=$(_LDFLAGS_ADD:0=-ldl)
LDFLAGS  += $(LDFLAGS_ADD)

# on gcc for arm there is no -m32, but -mbe32
M32FLAG = -m32
M64FLAG = -m64

CC_IS_GCC=$(shell $(CC) --version 2>/dev/null | grep -q gcc; echo $$?)
CC_IS_GCC:sh=$(CC) --version 2>/dev/null | grep -q gcc; echo $$?
CC_IS_ARMCOMPILER=$(shell $(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?)
CC_IS_ARMCOMPILER:sh=$(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?

_M32FLAG=$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)
__M32FLAG=$(_M32FLAG:00=-mbe32)
___M32FLAG=$(__M32FLAG:$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)=-m32)
M32FLAG=$(___M32FLAG)

all: argvfuzz32.so argvfuzz64.so

argvfuzz32.so: argvfuzz.c
	-@$(CC) $(M32FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "argvfuzz32 build failure (that's fine)"

argvfuzz64.so: argvfuzz.c
	-@$(CC) $(M64FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "argvfuzz64 build failure (that's fine)"

install: argvfuzz32.so argvfuzz64.so
	install -d -m 755 $(DESTDIR)$(HELPER_PATH)/
	if [ -f argvfuzz32.so ]; then set -e; install -m 755 argvfuzz32.so $(DESTDIR)$(HELPER_PATH)/; fi
	if [ -f argvfuzz64.so ]; then set -e; install -m 755 argvfuzz64.so $(DESTDIR)$(HELPER_PATH)/; fi

clean:
	rm -f argvfuzz32.so argvfuzz64.so

=== examples/persistent_demo/Makefile ===
all:
	afl-clang-fast -o persistent_demo persistent_demo.c
	afl-clang-fast -o persistent_demo_new persistent_demo_new.c
	AFL_DONT_OPTIMIZE=1 afl-clang-fast -o test-instr test-instr.c

document:
	AFL_DONT_OPTIMIZE=1 afl-clang-fast -D_AFL_DOCUMENT_MUTATIONS -o test-instr test-instr.c

clean:
	rm -f persistent_demo persistent_demo_new test-instr

=== qemu_mode/libcompcov/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 PREFIX      ?= /usr/local
 HELPER_PATH  = $(PREFIX)/lib/afl
 DOC_PATH    ?= $(PREFIX)/share/doc/afl
-MAN_PATH    ?= $(PREFIX)/man/man8
+MAN_PATH    ?= $(PREFIX)/share/man/man8
 
 VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

=== qemu_mode/unsigaction/Makefile ===
#
# american fuzzy lop++ - unsigaction
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2020 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
.POSIX:

_UNIQ=_QINU_

TARGETCANDIDATES=unsigaction32.so unsigaction64.so
_TARGETS=$(_UNIQ)$(AFL_NO_X86)$(_UNIQ)
__TARGETS=$(_TARGETS:$(_UNIQ)1$(_UNIQ)=)
TARGETS=$(__TARGETS:$(_UNIQ)$(_UNIQ)=$(TARGETCANDIDATES))

all:  $(TARGETS)
	@if [ "$(AFL_NO_X86)" != "" ]; then echo "[!] Note: skipping compilation of unsigaction (AFL_NO_X86 set)."; fi

unsigaction32.so:
	@if $(CC) -m32 -fPIC -shared unsigaction.c -o unsigaction32.so 2>/dev/null ; then echo "unsigaction32 build success"; else echo "unsigaction32 build failure (that's fine)"; fi

unsigaction64.so:
	@if $(CC) -m64 -fPIC -shared unsigaction.c -o unsigaction64.so 2>/dev/null ; then echo "unsigaction64 build success"; else echo "unsigaction64 build failure (that's fine)"; fi

clean:
	rm -f unsigaction32.so unsigaction64.so

=== unicorn_mode/samples/c/Makefile ===
# UnicornAFL Usage
# Original Unicorn Example Makefile by Nguyen Anh Quynh <aquynh@gmail.com>, 2015
# Adapted for AFL++ by domenukk <domenukk@gmail.com>, 2020
.POSIX:
UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make
_UNIQ=_QINU_

LIBDIR = ../../unicornafl
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../../unicornafl/include

LDFLAGS += -L$(LIBDIR) -lpthread -lm

_LRT = $(_UNIQ)$(UNAME_S:Linux=)
__LRT = $(_LRT:$(_UNIQ)=-lrt)
LRT = $(__LRT:$(_UNIQ)=)

LDFLAGS += $(LRT)

_CC = $(_UNIQ)$(CROSS)
__CC = $(_CC:$(_UNIQ)=$(CC))
MYCC = $(__CC:$(_UNIQ)$(CROSS)=$(CROSS)gcc)

.PHONY: all clean

all: harness

clean:
	rm -rf *.o harness harness-debug

harness.o: harness.c ../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -O3 -c harness.c

harness-debug.o: harness.c ../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -g -c harness.c -o $@

harness: harness.o
	${MYCC} -L${LIBDIR} harness.o ../../unicornafl/libunicornafl.a $(LDFLAGS) -o $@

debug: harness-debug.o
	${MYCC} -L${LIBDIR} harness.o ../../unicornafl/libunicornafl.a $(LDFLAGS) -o harness-debug

=== unicorn_mode/samples/persistent/Makefile ===
# UnicornAFL Usage
# Original Unicorn Example Makefile by Nguyen Anh Quynh <aquynh@gmail.com>, 2015
# Adapted for AFL++ by domenukk <domenukk@gmail.com>, 2020
.POSIX:
UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make
_UNIQ=_QINU_

LIBDIR = ../../unicornafl
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../../unicornafl/include

LDFLAGS += -L$(LIBDIR) -lpthread -lm

_LRT = $(_UNIQ)$(UNAME_S)
__LRT = $(_LRT:$(_UNIQ)Linux=-lrt)
LRT = $(__LRT:$(_UNIQ)$(UNAME_S)=)

LDFLAGS += $(LRT)

_CC = $(_UNIQ)$(CROSS)
__CC = $(_CC:$(_UNIQ)=$(CC))
MYCC = $(__CC:$(_UNIQ)$(CROSS)=$(CROSS)gcc)

.PHONY: all clean

all: harness

clean:
	rm -rf *.o harness harness-debug

harness.o: harness.c ../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -O3 -c harness.c

harness-debug.o: harness.c ../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -DAFL_DEBUG=1 -g -c harness.c -o $@

harness: harness.o
	${MYCC} -L${LIBDIR} harness.o ../../unicornafl/libunicornafl.a $(LDFLAGS) -o $@

debug: harness-debug.o
	${MYCC} -L${LIBDIR} harness-debug.o ../../unicornafl/libunicornafl.a $(LDFLAGS) -o harness-debug

fuzz: harness
	../../../afl-fuzz -m none -i sample_inputs -o out -- ./harness @@

debugmake:
	@echo UNAME_S=$(UNAME_S), _LRT=$(_LRT), __LRT=$(__LRT), LRT=$(LRT)

=== debian/changelog ===
aflplusplus (2.68c-1) unstable; urgency=medium

  * New upstream version 2.68c
  * Add a patch to improve reproducibility (Closes: #969320)
  * Improve long description to make it clear that afl is unmaintained
    (Closes: #973557)
  * Switch to clang/LLVM 11 (Closes: #974783)
  * Drop all patches, they have been merged upstream.

 -- Raphaël Hertzog <raphael@offensive-security.com>  Tue, 17 Nov 2020 12:06:15 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends:
- clang-10,
+ clang-11,
  debhelper-compat (= 13),
  dh-buildinfo,
- llvm-10-dev,
+ llvm-11-dev,
  python3-dev
 Standards-Version: 4.5.0
 Homepage: https://github.com/vanhauser-thc/AFLplusplus
@@ -36,7 +36,7 @@
  essentially no configuration, and seamlessly handles complex, real-world use
  cases - say, common image parsing or file compression libraries.
  .
- This package is a fork of the afl package that is no longer maintained.
+ afl++ is a fork of the unmaintained afl.
 
 Package: afl++-clang
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 # Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
-export LLVM_MAJOR_VERSION = 10
+export LLVM_MAJOR_VERSION = 11
 export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)
 
 %:

=== debian/tests/control ===
Tests: smoke-test-gcc
Depends: afl++, build-essential
Restrictions: allow-stderr

Tests: smoke-test-clang
Depends: afl++-clang, build-essential
Restrictions: allow-stderr

Tests: smoke-test-clang-fast
Depends: afl++-clang, build-essential
Restrictions: allow-stderr

Tests: adequate-afl
Depends: adequate, afl++

Tests: adequate-afl-clang
Depends: adequate, afl++-clang

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d.*)\.tar\.gz%aflplusplus-$1.tar.gz%" \
    https://github.com/vanhauser-thc/AFLplusplus/tags \
    (?:.*?/)?v?(\d.*)\.tar\.gz debian uupdate

## aflplusplus 3.14c

=== qemu_mode/unsigaction/Makefile ===
#
# american fuzzy lop++ - unsigaction
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2020 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
.POSIX:

_UNIQ=_QINU_

TARGETCANDIDATES=unsigaction.so
_TARGETS=$(_UNIQ)$(AFL_NO_X86)$(_UNIQ)
__TARGETS=$(_TARGETS:$(_UNIQ)1$(_UNIQ)=)
TARGETS=$(__TARGETS:$(_UNIQ)$(_UNIQ)=$(TARGETCANDIDATES))

all:  $(TARGETS)

unsigaction.so: unsigaction.c
	@if $(CC) -fPIC -shared unsigaction.c -o unsigaction.so 2>/dev/null ; then echo "unsigaction build success"; else echo "unsigaction build failure (that's fine)"; fi

clean:
	rm -f unsigaction.so

=== unicorn_mode/samples/speedtest/c/Makefile ===
# UnicornAFL Usage
# Original Unicorn Example Makefile by Nguyen Anh Quynh <aquynh@gmail.com>, 2015
# Adapted for AFL++ by domenukk <domenukk@gmail.com>, 2020
.POSIX:
UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make
_UNIQ=_QINU_

LIBDIR = ../../../unicornafl
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -Wextra -Wno-unused-parameter -I../../../unicornafl/include

LDFLAGS += -L$(LIBDIR) -lpthread -lm

_LRT = $(_UNIQ)$(UNAME_S:Linux=)
__LRT = $(_LRT:$(_UNIQ)=-lrt)
LRT = $(__LRT:$(_UNIQ)=)

LDFLAGS += $(LRT)

_CC = $(_UNIQ)$(CROSS)
__CC = $(_CC:$(_UNIQ)=$(CC))
MYCC = $(__CC:$(_UNIQ)$(CROSS)=$(CROSS)gcc)

.PHONY: all clean

all: ../target harness

afl-fuzz: ../../../../afl-fuzz
../../../../afl-fuzz:
	$(MAKE) -C ../../../../ afl-fuzz

clean:
	rm -rf *.o harness harness-debug

harness.o: harness.c ../../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -O3 -c harness.c -o $@

harness-debug.o: harness.c ../../../unicornafl/include/unicorn/*.h
	${MYCC} ${CFLAGS} -fsanitize=address -g -Og -c harness.c -o $@

harness: harness.o
	${MYCC} -L${LIBDIR} harness.o ../../../unicornafl/libunicornafl.a $(LDFLAGS) -o $@

harness-debug: harness-debug.o
	${MYCC} -fsanitize=address -g -Og -L${LIBDIR} harness-debug.o ../../../unicornafl/libunicornafl.a $(LDFLAGS) -o harness-debug

../target:
	$(MAKE) -C ..

fuzz: all afl-fuzz
	rm -rf ./output
	SKIP_BIN_CHECK=1 ../../../../afl-fuzz -s 1 -i ../sample_inputs -o ./output -- ./harness @@
